xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 6c8c1406)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12#   ^
13#   |
14#   +--< vmlinux.a
15#   |
16#   +--< $(KBUILD_VMLINUX_LIBS)
17#   |    +--< lib/lib.a + more
18#   |
19#   +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
35is_enabled() {
36	grep -q "^$1=y" include/config/auto.conf
37}
38
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
43	printf "  %-7s %s\n" "${1}" "${2}"
44}
45
46# Link of vmlinux
47# ${1} - output file
48# ${2}, ${3}, ... - optional extra .o files
49vmlinux_link()
50{
51	local output=${1}
52	local objs
53	local libs
54	local ld
55	local ldflags
56	local ldlibs
57
58	info LD ${output}
59
60	# skip output file argument
61	shift
62
63	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
64		# Use vmlinux.o instead of performing the slow LTO link again.
65		objs=vmlinux.o
66		libs=
67	else
68		objs=vmlinux.a
69		libs="${KBUILD_VMLINUX_LIBS}"
70	fi
71
72	if is_enabled CONFIG_MODULES; then
73		objs="${objs} .vmlinux.export.o"
74	fi
75
76	objs="${objs} init/version-timestamp.o"
77
78	if [ "${SRCARCH}" = "um" ]; then
79		wl=-Wl,
80		ld="${CC}"
81		ldflags="${CFLAGS_vmlinux}"
82		ldlibs="-lutil -lrt -lpthread"
83	else
84		wl=
85		ld="${LD}"
86		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
87		ldlibs=
88	fi
89
90	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
91
92	# The kallsyms linking does not need debug symbols included.
93	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
94		ldflags="${ldflags} ${wl}--strip-debug"
95	fi
96
97	if is_enabled CONFIG_VMLINUX_MAP; then
98		ldflags="${ldflags} ${wl}-Map=${output}.map"
99	fi
100
101	${ld} ${ldflags} -o ${output}					\
102		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
103		${wl}--start-group ${libs} ${wl}--end-group		\
104		$@ ${ldlibs}
105}
106
107# generate .BTF typeinfo from DWARF debuginfo
108# ${1} - vmlinux image
109# ${2} - file to dump raw BTF data into
110gen_btf()
111{
112	local pahole_ver
113
114	if ! [ -x "$(command -v ${PAHOLE})" ]; then
115		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
116		return 1
117	fi
118
119	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
120	if [ "${pahole_ver}" -lt "116" ]; then
121		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
122		return 1
123	fi
124
125	vmlinux_link ${1}
126
127	info "BTF" ${2}
128	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
129
130	# Create ${2} which contains just .BTF section but no symbols. Add
131	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132	# deletes all symbols including __start_BTF and __stop_BTF, which will
133	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
134	# objcopy warnings: "empty loadable segment detected at ..."
135	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136		--strip-all ${1} ${2} 2>/dev/null
137	# Change e_type to ET_REL so that it can be used to link final vmlinux.
138	# Unlike GNU ld, lld does not allow an ET_EXEC input.
139	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
140}
141
142# Create ${2} .S file with all symbols from the ${1} object file
143kallsyms()
144{
145	local kallsymopt;
146
147	if is_enabled CONFIG_KALLSYMS_ALL; then
148		kallsymopt="${kallsymopt} --all-symbols"
149	fi
150
151	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
152		kallsymopt="${kallsymopt} --absolute-percpu"
153	fi
154
155	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
156		kallsymopt="${kallsymopt} --base-relative"
157	fi
158
159	info KSYMS ${2}
160	scripts/kallsyms ${kallsymopt} ${1} > ${2}
161}
162
163# Perform one step in kallsyms generation, including temporary linking of
164# vmlinux.
165kallsyms_step()
166{
167	kallsymso_prev=${kallsymso}
168	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
169	kallsymso=${kallsyms_vmlinux}.o
170	kallsyms_S=${kallsyms_vmlinux}.S
171
172	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
173	mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms
174	kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
175
176	info AS ${kallsyms_S}
177	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
178	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
179	      -c -o ${kallsymso} ${kallsyms_S}
180}
181
182# Create map file with all symbols from ${1}
183# See mksymap for additional details
184mksysmap()
185{
186	info NM ${2}
187	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
188}
189
190sorttable()
191{
192	${objtree}/scripts/sorttable ${1}
193}
194
195# Delete output files in case of error
196cleanup()
197{
198	rm -f .btf.*
199	rm -f System.map
200	rm -f vmlinux
201	rm -f vmlinux.map
202}
203
204# Use "make V=1" to debug this script
205case "${KBUILD_VERBOSE}" in
206*1*)
207	set -x
208	;;
209esac
210
211if [ "$1" = "clean" ]; then
212	cleanup
213	exit 0
214fi
215
216${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
217
218btf_vmlinux_bin_o=""
219if is_enabled CONFIG_DEBUG_INFO_BTF; then
220	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
221	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
222		echo >&2 "Failed to generate BTF for vmlinux"
223		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
224		exit 1
225	fi
226fi
227
228kallsymso=""
229kallsymso_prev=""
230kallsyms_vmlinux=""
231if is_enabled CONFIG_KALLSYMS; then
232
233	# kallsyms support
234	# Generate section listing all symbols and add it into vmlinux
235	# It's a three step process:
236	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
237	#     but __kallsyms is empty.
238	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
239	#     the right size
240	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
241	#     the right size, but due to the added section, some
242	#     addresses have shifted.
243	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
244	# 3)  That link may have expanded the kernel image enough that
245	#     more linker branch stubs / trampolines had to be added, which
246	#     introduces new names, which further expands kallsyms. Do another
247	#     pass if that is the case. In theory it's possible this results
248	#     in even more stubs, but unlikely.
249	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
250	#     other bugs.
251	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
252	#
253	# a)  Verify that the System.map from vmlinux matches the map from
254	#     ${kallsymso}.
255
256	kallsyms_step 1
257	kallsyms_step 2
258
259	# step 3
260	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
261	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
262
263	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
264		kallsyms_step 3
265	fi
266fi
267
268vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
269
270# fill in BTF IDs
271if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
272	info BTFIDS vmlinux
273	${RESOLVE_BTFIDS} vmlinux
274fi
275
276mksysmap vmlinux System.map
277
278if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
279	info SORTTAB vmlinux
280	if ! sorttable vmlinux; then
281		echo >&2 Failed to sort kernel tables
282		exit 1
283	fi
284fi
285
286# step a (see comment above)
287if is_enabled CONFIG_KALLSYMS; then
288	if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
289		echo >&2 Inconsistent kallsyms data
290		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
291		exit 1
292	fi
293fi
294
295# For fixdep
296echo "vmlinux: $0" > .vmlinux.d
297